#include <stdio.h>

#define pascal_h

#include <libclient.h>
#include <libtypes.h>
#include <libmsgs.h>
#include <libsupport.h>
#include <libstrucs.h>

#include "platform.h"
#include "xmlcfg.h"
#include "xmlseed.h"

//  #ifdef USE_GCC_PACKING
//  enum tpacket_class {PKC_DATA, PKC_EVENT, PKC_CALIBRATE, PKC_TIMING, PKC_MESSAGE, PKC_OPAQUE}  __attribute__ ((__packed__)) ;
//  #else
//  enum tpacket_class {PKC_DATA, PKC_EVENT, PKC_CALIBRATE, PKC_TIMING, PKC_MESSAGE, PKC_OPAQUE} ;
//  #endif

//  typedef struct { /* format for miniseed and archival miniseed */
//    tcontext context ;
//    string9 station_name ; /* network and station */
//    string2 location ;
//    byte chan_number ; /* channel number according to tokens */
//    string3 channel ;
//    integer rate ; /* sampling rate */
//    double timestamp ; /* Time of data, corrected for any filtering */
//    word filter_bits ; /* OMF_xxx bits */
//    enum tpacket_class packet_class ; /* type of record */
//    enum tminiseed_action miniseed_action ; /* what this packet represents */
//    word data_size ; /* size of actual miniseed data */
//    pointer data_address ; /* pointer to miniseed record */
//  } tminiseed_call ;

int main (int argc, char **argv) 
{
    /* Object we want to check size of based on gcc compilation options for packing. */

    enum tpacket_class packet_class ; /* type of record */
    tminiseed_call miniseed_call ; /* buffer for building miniseed callbacks */
    
    printf ("sizeof(packet_class) = %d\n", sizeof(packet_class));
    printf ("sizeof(miniseed_call) = %d\n", sizeof(miniseed_call));
    printf ("\n");

    /* Determine the size offsets of items within the structure. */
    char *foo = "\
a b /* c */ d";

    char *tminiseed_call_string = "\
typedef struct { /* format for miniseed and archival miniseed */\
  tcontext context ;\
  string9 station_name ; /* network and station */\
  string2 location ;\
  byte chan_number ; /* channel number according to tokens */\
  string3 channel ;\
  integer rate ; /* sampling rate */\
  double timestamp ; /* Time of data, corrected for any filtering */\
  word filter_bits ; /* OMF_xxx bits */\
  enum tpacket_class packet_class ; /* type of record */\
  enum tminiseed_action miniseed_action ; /* what this packet represents */\
  word data_size ; /* size of actual miniseed data */\
  pointer data_address ; /* pointer to miniseed record */\
} tminiseed_call ;\
";

//context
    printf ("offset context = %d, sizeof(context) = %d\n",
	    (void *)&miniseed_call.context - (void *)&miniseed_call, sizeof(miniseed_call.context));
//station_name
    printf ("offset station_name = %d, sizeof(station_name) = %d\n",
	    (void *)&miniseed_call.station_name - (void *)&miniseed_call, sizeof(miniseed_call.station_name));
//location
    printf ("offset location = %d, sizeof(location) = %d\n",
	    (void *)&miniseed_call.location - (void *)&miniseed_call, sizeof(miniseed_call.location));
//chan_number
    printf ("offset chan_number = %d, sizeof(chan_number) = %d\n",
	    (void *)&miniseed_call.chan_number - (void *)&miniseed_call, sizeof(miniseed_call.chan_number));
//channel
    printf ("offset channel = %d, sizeof(channel) = %d\n",
	    (void *)&miniseed_call.channel - (void *)&miniseed_call, sizeof(miniseed_call.channel));
//rate
    printf ("offset rate = %d, sizeof(rate) = %d\n",
	    (void *)&miniseed_call.rate - (void *)&miniseed_call, sizeof(miniseed_call.rate));
//timestamp
    printf ("offset timestamp = %d, sizeof(timestamp) = %d\n",
	    (void *)&miniseed_call.timestamp - (void *)&miniseed_call, sizeof(miniseed_call.timestamp));
//filter_bits
    printf ("offset filter_bits = %d, sizeof(filter_bits) = %d\n",
	    (void *)&miniseed_call.filter_bits - (void *)&miniseed_call, sizeof(miniseed_call.filter_bits));
//tpacket_class
    printf ("offset packet_class = %d, sizeof(packet_class) = %d\n",
	    (void *)&miniseed_call.packet_class - (void *)&miniseed_call, sizeof(miniseed_call.packet_class));
//tminiseed_action
   printf ("offset miniseed_action = %d, sizeof(miniseed_action) = %d\n",
	   (void *)&miniseed_call.miniseed_action - (void *)&miniseed_call, sizeof(miniseed_call.miniseed_action));
//data_size
    printf ("offset data_size = %d, sizeof(data_size) = %d\n",
	    (void *)&miniseed_call.data_size - (void *)&miniseed_call, sizeof(miniseed_call.data_size));
//data_address
    printf ("offset data_address = %d, sizeof(data_address) = %d\n",
	    (void *)&miniseed_call.data_address - (void *)&miniseed_call, sizeof(miniseed_call.data_address));

    return 0;
}
